Subject: Re: [EXT] Re: [RFC, net-next] net: qos: introduce a frer action to implement 802.1CB

From: Vinicius Costa Gomes <[email-masked]>
Date: Fri, 01 Oct 2021 10:13:44 -0700

Hi Vladimir,

Vladimir Oltean <[email-masked]> writes:

> Hi Vinicius,
>
> On Wed, Sep 29, 2021 at 10:25:58AM +0000, Xiaoliang Yang wrote:
>> Hi Vinicius,
>>
>> On Sep 29, 2021 at 6:35:59 +0000, Vinicius Costa Gomes wrote:
>> > > This patch introduce a frer action to implement frame replication and
>> > > elimination for reliability, which is defined in IEEE P802.1CB.
>> > >
>> >
>> > An action seems, to me, a bit too limiting/fine grained for a frame replication
>> > and elimination feature.
>> >
>> > At least I want to hear the reasons that the current hsr/prp support cannot be
>> > extended to support one more tag format/protocol.
>> >
>> > And the current name for the spec is IEEE 802.1CB-2017.
>> >
>> 802.1CB can be set on bridge ports, and need to use bridge forward
>> Function as a relay system. It only works on identified streams,
>> unrecognized flows still need to pass through the bridged network
>> normally.
>>
>> But current hsr/prp seems only support two ports, and cannot use the
>> ports in bridge. It's hard to implement FRER functions on current HSR
>> driver.
>>
>> You can see chapter "D.2 Example 2: Various stack positions" in IEEE 802.1CB-2017,
>> Protocol stack for relay system is like follows:
>>
>>              Stream Transfer Function
>>                 |             |
>>                 |        Sequence generation
>>                 |            Sequence encode/decode
>>   Stream identification        Active Stream identification
>>                 |              |
>>                 |        Internal LAN---- Relay system forwarding
>>                 |                        |        |
>>                 MAC                    MAC        MAC
>>
>> Use port actions to easily implement FRER tag add/delete, split, and
>> recover functions.
>>
>> Current HSR/PRP driver can be used for port HSR/PRP set, and tc-frer
>> Action to be used for stream RTAG/HSR/PRP set and recover.
>
> Did Xiaoliang answer your question satisfactorily? :)

Oh, yes, the answer was very good. I was taking some time to read the
802.1CB spec, and try to think how things would fit together so I can
ask better questions next time :-)

Cheers,
-- 
Vinicius